import { MutationBehavior, MutationQueryReducersMap } from 'apollo-client/data/mutationResults';
import { Document, FragmentDefinition } from 'graphql';
export interface MutationOptions {
    variables?: Object;
    resultBehaviors?: MutationBehavior[];
    fragments?: FragmentDefinition[];
    optimisticResponse?: Object;
    updateQueries?: MutationQueryReducersMap;
}
export interface QueryOptions {
    ssr?: boolean;
    variables?: {
        [key: string]: any;
    };
    forceFetch?: boolean;
    returnPartialData?: boolean;
    noFetch?: boolean;
    pollInterval?: number;
    fragments?: FragmentDefinition[];
    skip?: boolean;
}
export declare function withApollo(WrappedComponent: any): any;
export interface OperationOption {
    mapPropsToOptions?: (props: any) => QueryOptions | MutationOptions;
    mapResultToProps?: (props: any) => any;
}
export default function graphql(document: Document, operationOptions?: OperationOption): (WrappedComponent: any) => any;
